"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runTypeChain = void 0;
const fs = __importStar(require("fs"));
const mkdirp_1 = require("mkdirp");
const path_1 = require("path");
const prettier = __importStar(require("prettier"));
const debug_1 = require("../utils/debug");
const findTarget_1 = require("./findTarget");
const io_1 = require("./io");
async function runTypeChain(publicConfig) {
    const _config = { ...{ flags: { alwaysGenerateOverloads: false, environment: undefined } }, ...publicConfig };
    // skip empty paths
    const config = {
        ..._config,
        allFiles: io_1.skipEmptyAbis(_config.allFiles),
        filesToProcess: io_1.skipEmptyAbis(_config.filesToProcess),
    };
    const services = {
        fs,
        prettier,
        mkdirp: mkdirp_1.sync,
    };
    let filesGenerated = 0;
    const target = findTarget_1.findTarget(config);
    const fileDescriptions = io_1.loadFileDescriptions(services, config.filesToProcess);
    debug_1.debug('Executing beforeRun()');
    filesGenerated += io_1.processOutput(services, config, await target.beforeRun());
    debug_1.debug('Executing beforeRun()');
    for (const fd of fileDescriptions) {
        debug_1.debug(`Processing ${path_1.relative(config.cwd, fd.path)}`);
        filesGenerated += io_1.processOutput(services, config, await target.transformFile(fd));
    }
    debug_1.debug('Running afterRun()');
    filesGenerated += io_1.processOutput(services, config, await target.afterRun());
    return {
        filesGenerated,
    };
}
exports.runTypeChain = runTypeChain;
//# sourceMappingURL=runTypeChain.js.map